package com.programaker.api.data

import android.util.Log
import org.json.JSONArray
import org.json.JSONObject
import java.util.*

class ProgramakerCustomBlockArgument(
        val type: String?,
        val default_value: String?,
        // val class: String,
        val callback: String?
) {
    fun serialize():  JSONObject {
        val serialized = hashMapOf<String, JSONObject>()

        return JSONObject(serialized as Map<*, *>)
    }

    companion object {
        @JvmStatic
        fun deserialize(arguments: JSONArray?): List<ProgramakerCustomBlockArgument> {
            if (arguments == null) {
                return listOf();
            }
            val results: MutableList<ProgramakerCustomBlockArgument> = LinkedList()

            var i = 0;
            while (i < arguments.length()) {
                val obj = arguments.getJSONObject(i)
                if (obj == null) {
                    Log.e("PMCustomBlockArgument", "Looped into a null value!?")
                }
                else {
                    results.add(deserialize(obj))
                }

                i += 1;
            }

            return results
        }

        private fun deserialize(arguments: JSONObject): ProgramakerCustomBlockArgument {
            var type: String? = null
            var default_value: String? = null
            var callback: String? = null

            if (arguments.has("type")) {
                type = arguments.getString("type")
            }
            if (arguments.has("default_value")) {
                default_value = arguments.getString("default_value")
            }
            if (arguments.has("callback")) {
                callback = arguments.getString("callback")
            }

            return ProgramakerCustomBlockArgument(type, default_value, callback)
        }
    }

}
